#ifndef PGM_H
#define PGM_H

#include <stdio.h>
#include <stdlib.h> 
#include <stdint.h>
#include "matrix.h"
#include "gfx.h"

typedef struct _pgm{
    int32_t max;
    matrix pixels;
}pgm;

typedef enum _pgm_error {
    success, failure
}pgm_error;

pgm_error pgm_read_from_file(pgm *p, char *filename);
pgm_error pgm_write_to_file(pgm *p, char *filename);
pgm_error pgm_negative(pgm *neg, const pgm *const orig);
pgm_error pgm_symmetry_hori(pgm *sym, const pgm *const orig);
pgm_error pgm_symmetry_vert(pgm *sym, const pgm *const orig);
pgm_error pgm_symmetry_cent(pgm *sym, const pgm *const orig);
pgm_error pgm_photomaton(pgm *photomaton, const pgm *const orig);
pgm_error pgm_crop(pgm *crop, const pgm *const orig, int32_t x0, int32_t x1, int32_t y0, int32_t y1);
pgm_error add_zeros_in_pgm(pgm *zeroedPgm, const pgm *const orig);
int calculate_pixel_conv(const matrix m, const matrix *const kernel, int max);
pgm_error pmg_conv(pgm *conv, const pgm *const orig, const matrix *const kernel, double norm);
pgm_error demo(const pgm *const img);

#endif