#include "pgm.h"

int main(){
    //variables initialization
    pgm a;
    pgm neg;
    pgm sym_hori;
    pgm sym_vert;
    pgm sym_cent;
    pgm photomatonx4;
    pgm photomatonx16;
    pgm cropped;
    pgm pgmWithZeros;
    pgm convolution;

    int conv[9] = {1,1,1,1,1,1,1,1,1};
    matrix convKernel;
    matrix_init_from_array(&convKernel, 3, 3, conv, 9);


    //Read pgm
    printf("%d", pgm_read_from_file(&a, "mandrill.pgm"));

    //Negative
    printf("%d", pgm_negative(&neg, &a));

    //horizontal symmetry
    printf("%d", pgm_symmetry_hori(&sym_hori, &a));

    //vertical symmetry
    printf("%d", pgm_symmetry_vert(&sym_vert, &a));

    //central symmetry
    printf("%d", pgm_symmetry_cent(&sym_cent, &a));

    //Photomaton x4
    printf("%d", pgm_photomaton(&photomatonx4, &a));


    //Photomaton x16
    printf("%d", pgm_photomaton(&photomatonx16, &photomatonx4));

    //Crop
    printf("%d", pgm_crop(&cropped, &a, 100, 200, 200, 500));

    //Convolution
    printf("%d", add_zeros_in_pgm(&pgmWithZeros, &a));
    printf("%d", pmg_conv(&convolution, &pgmWithZeros, &convKernel, 1));


    demo(&neg);
    demo(&sym_hori);
    demo(&sym_vert);
    demo(&sym_cent);
    demo(&photomatonx4);
    demo(&photomatonx16);
    demo(&cropped);
    demo(&convolution);


    //Destroying pgm's matrixes
    matrix_destroy(&a.pixels);
    matrix_destroy(&neg.pixels);
    matrix_destroy(&sym_hori.pixels);
    matrix_destroy(&sym_vert.pixels);
    matrix_destroy(&sym_cent.pixels);
    matrix_destroy(&photomatonx4.pixels);
    matrix_destroy(&photomatonx16.pixels);
    matrix_destroy(&cropped.pixels);
    matrix_destroy(&pgmWithZeros.pixels);
    matrix_destroy(&convolution.pixels);
    matrix_destroy(&convKernel);

    return EXIT_SUCCESS;
}   